Imports System.Xml
Imports System.IO
Imports Microsoft.Data.SqlXml
Imports System.Net
Imports System.Text

Namespace NorthWeb

    Public Class CProduct

        '============================================
        'Legge i prodotti ritornando un Documento XML
        '============================================
        Public Function GetProducts() As XmlDocument
            Dim _resultDoc As New XmlDocument()
            Dim _memoryStream As New MemoryStream()
            Dim _streamReader As New StreamReader(_memoryStream)
            _memoryStream.Position = 0

            Dim _command As SqlXmlCommand = New SqlXmlCommand(GlobalFunctions.SQLConnectionString)
            _command.CommandText = "SELECT * FROM Products FOR XML AUTO"
            Try

                _command.ExecuteToStream(_memoryStream)

                Dim _root As XmlNode = _resultDoc.CreateElement("ROOT")
                _resultDoc.AppendChild(_root)
                _memoryStream.Position = 0
                _root.InnerXml = _streamReader.ReadToEnd()

                GetProducts = _resultDoc

            Catch sqlEx As SqlXmlException
                GetProducts = Nothing
            End Try
        End Function

        Public Function ExecuteTemplate(ByVal TemplateName As String) As String
            Dim _result As New XmlDataDocument()

            Dim _command As SqlXmlCommand = New SqlXmlCommand(GlobalFunctions.SQLConnectionString)
            _command.CommandType = SqlXmlCommandType.TemplateFile
            _command.CommandText = Path.Combine(GlobalFunctions.TemplateDirectory, TemplateName & ".xml")
            Dim _stream As Stream = _command.ExecuteStream()
            Dim _sr As StreamReader = New StreamReader(_stream)

            Return _sr.ReadToEnd()

        End Function

        '============================================================================
        ' Esegue un template remoto 
        ' ritornando una stringa formattata come un documento XML
        '============================================================================
        Public Function ExecuteRemoteTemplate(ByVal TemplateName As String) As String            
            Dim strReq = GlobalFunctions.IISConnectionURL & "/Template/" & TemplateName
            Dim _request As WebRequest = WebRequest.Create(strReq)
            _request.Credentials = CredentialCache.DefaultCredentials
            Dim _response As WebResponse = _request.GetResponse()
            Dim respStream As Stream = _response.GetResponseStream()
            Dim reader As StreamReader = New StreamReader(respStream, Encoding.ASCII)
            Dim respXML As String = reader.ReadToEnd()
            respStream.Close()
            Return respXML
        End Function

        Public Function GetRemoteXMLDocument(ByVal TemplateName As String) As XmlDocument
            Dim _docContent As String = ExecuteRemoteTemplate(TemplateName)
            Dim _document As New XmlDocument()

            _document.LoadXml(_docContent)

            Return _document
        End Function

    End Class

End Namespace